/* @(#) pSOSystem ARM/V2.2.1: bin/source/make2bat/global.h 2.5 95/12/13 19:32:44 */
/***********************************************************************/
/*                                                                     */
/*   MODULE:  bin/source/make/global.h                                 */
/*   DATE:    95/12/13                                                 */
/*   PURPOSE: Function prototypes                                      */
/*                                                                     */
/*---------------------------------------------------------------------*/
/*                                                                     */
/*           Copyright 1991 - 1995, Integrated Systems, Inc.           */
/*                      ALL RIGHTS RESERVED                            */
/*                                                                     */
/*   Permission is hereby granted to licensees of Integrated Systems,  */
/*   Inc. products to use or abstract this computer program for the    */
/*   sole purpose of implementing a product based on Integrated        */
/*   Systems, Inc. products.   No other rights to reproduce, use,      */
/*   or disseminate this computer program, whether in part or in       */
/*   whole, are granted.                                               */
/*                                                                     */
/*   Integrated Systems, Inc. makes no representation or warranties    */
/*   with respect to the performance of this computer program, and     */
/*   specifically disclaims any responsibility for any damages,        */
/*   special or consequential, connected with the use of this program. */
/*                                                                     */
/***********************************************************************/

/*---------------------------------------------------------------------*/
/* Fatal error handling routines (err.c)                               */
/*---------------------------------------------------------------------*/
void ErrInit(void);
void ErrFilePush(const char *FileName);
void ErrFileIncLineno(void);
void ErrFilePop(void);
void Err(const char *msg);
void ErrInt(const char *msg, int arg);
void ErrPtr(const char *msg, void *ptr);
void ErrStr(const char *msg, const char *str);

/*---------------------------------------------------------------------*/
/* Dynamic memory allocation/de-allocation routines (mem.c)            */
/*---------------------------------------------------------------------*/
void  MemInit(void);
char *MemAlloc(int nbytes);
char *MemNewString(const char *string);
void  MemFree(char *ptr);

/*---------------------------------------------------------------------*/
/* Macro definition & lookup routines (macro.c)                        */
/*---------------------------------------------------------------------*/
void MacroInit(void);
void MacroDefine(const char *name, const char *value, int where);
char *MacroExpand(char *InputString, int InputLen);
void MacroDump(void);

/*---------------------------------------------------------------------*/
/* Rules definition and lookup (rules.c)                               */
/*---------------------------------------------------------------------*/
void RulesInit(void);
int RulesFind(char *name, char NotBuiltFlag);
void RulesMarkBuilt(char *target);
char *RulesFindDependency(char *target, int index);
char *RulesFindAction(char *target, int index);
void RulesMake(char *target);
void RulesAddDependency(char *target, char *dependency);
void RulesAddAction(char *target, char *action);
void RulesDump(void);

/*---------------------------------------------------------------------*/
/* Macro attributes, specify where it was defined.                     */
/*---------------------------------------------------------------------*/
#define	M_FILE     'F'
#define	M_ENV      'E'
#define M_CMD_LINE 'C'
